#ifndef CONTACTSJSONCONTROLLER_H
#define CONTACTSJSONCONTROLLER_H

#include <QObject>
#include <QDate>

//Classes that handles JSON
#include <QJsonDocument>
#include <QJsonValue>
#include <QJsonObject>
#include <QJsonArray>

//Класс DAO для объекта Адрес
class Address
{
public:
    Address(QJsonObject jObj);
    QJsonObject toJsonObject();
private:
    QString _city;
    QString _street;
    int _number;
};

//Класс DAO для объекта Контакт
class Contact
{
public:
    Contact(QJsonObject jObj);
    QJsonObject toJsonObject();
private:
    QString _name;
    QDate _birthDate;
    QList<Address> _addresses;
};

//Класс контроллер справочника контактов
class ContactsJsonController
{
public:
    ContactsJsonController();
    //Получение списка всех контактов
    QByteArray list();
    //Добавление контакта в справочник
    void append(QByteArray json);
    //Очистка справочника
    void clear();
private:
    QList<Contact> _items;
};

#endif // CONTACTSJSONCONTROLLER_H
