#include "onethreadserver.h"
#include <QTcpSocket>
#include <QDebug>


OneThreadServer::OneThreadServer(QObject *parent) : QTcpServer(parent)
{
    int port = 80;
    if (listen(QHostAddress::Any, port)) {
        qDebug() << "Listening on port:" << port;
    }
    else {
        qCritical() << "Error while starting server:" << errorString();
    }
}

void OneThreadServer::incomingConnection(qintptr handle)
{
    qDebug() << "incomming connection:" << handle;
    QTcpSocket* socket = new QTcpSocket();
    socket->setSocketDescriptor(handle);
    connect(socket, SIGNAL(readyRead()), this, SLOT(onReadyRead()));
    connect(socket, SIGNAL(disconnected()), this, SLOT(onDisconnected()));
}

void OneThreadServer::onReadyRead()
{
    qDebug() << "onReadyRead";
    QTcpSocket* socket = qobject_cast<QTcpSocket*>(sender());
    QString request = socket->readAll();
    qDebug() << request;
    socket->write("HTTP/1.1 200 OK\r\n\r\n");    
    //Если метод HTTP запроса GET
    if (request.startsWith("GET")) {
        socket->write(controller.list());
    }
    //Если метод HTTP запроса PUT
    else if (request.startsWith("PUT")) {
        QString data = request.section("\r\n\r\n", 1, 1);
        controller.append(data.toUtf8());
    }
    //Если метод HTTP запроса DELETE
    else if (request.startsWith("DELETE")) {
        controller.clear();
    }

    socket->disconnectFromHost();
}

void OneThreadServer::onDisconnected()
{
    QTcpSocket* socket = qobject_cast<QTcpSocket*>(sender());
    socket->close();
    socket->deleteLater();
}
